#include <iostream>
#include <string.h>
#include <cstring>

#include <security/pam_appl.h>

int convers(int num_msg, const struct pam_message **msg, struct pam_response
		**resp, void *appdata) {
	*resp = new pam_response[num_msg];
	auto &arr = *resp;

	for (size_t n = 0; n < num_msg; n++) {
		arr[n].resp_retcode = 0;
		arr[n].resp = new char[128];
		std::memcpy(arr[n].resp, "password", 9);
	}

	return PAM_SUCCESS;
}

int main(int argc, const char **argv) {

	struct pam_conv conv = { convers, NULL };
	pam_handle_t *pamh;
	int err;

	/* Initialize PAM framework */
	err = pam_start("gromox", "username", &conv, &pamh);
	if (err != PAM_SUCCESS) {
		std::cerr << "pam_start failed: " << pam_strerror(pamh, err);
		return 1;
	}

	/* Authenticate user */
	err = pam_authenticate(pamh, 0);
	switch (err) {
		case PAM_AUTH_ERR: std::cerr << "AUTH_ERR\n"; break;
		case PAM_SUCCESS: std::cerr << "SUCCESS\n"; break;
		default: std::cerr << "PAM ERR: " << err << "\n"; break;
	}

	pam_end(pamh, 0);

	return 0;
}
